using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Accessing_image_data
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblCoords;
		private System.Windows.Forms.TextBox txtImageData;
		private TIS.Imaging.ICImagingControl icImagingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.lblCoords = new System.Windows.Forms.Label();
            this.txtImageData = new System.Windows.Forms.TextBox();
            this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 280);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(80, 16);
            this.label1.TabIndex = 1;
            this.label1.Text = "Image data @";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 8);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(264, 16);
            this.label2.TabIndex = 2;
            this.label2.Text = "Move the mouse over the live video to select a pixel";
            // 
            // lblCoords
            // 
            this.lblCoords.Location = new System.Drawing.Point(88, 280);
            this.lblCoords.Name = "lblCoords";
            this.lblCoords.Size = new System.Drawing.Size(48, 16);
            this.lblCoords.TabIndex = 3;
            this.lblCoords.Text = "N/A";
            // 
            // txtImageData
            // 
            this.txtImageData.Location = new System.Drawing.Point(144, 280);
            this.txtImageData.Multiline = true;
            this.txtImageData.Name = "txtImageData";
            this.txtImageData.Size = new System.Drawing.Size(96, 64);
            this.txtImageData.TabIndex = 4;
            this.txtImageData.Text = "N/A";
            // 
            // icImagingControl1
            // 
            this.icImagingControl1.BackColor = System.Drawing.Color.White;
            this.icImagingControl1.DeviceLostExecutionMode = TIS.Imaging.EventExecutionMode.AsyncInvoke;
            this.icImagingControl1.ImageAvailableExecutionMode = TIS.Imaging.EventExecutionMode.MultiThreaded;
            this.icImagingControl1.LiveDisplayPosition = new System.Drawing.Point(0, 0);
            this.icImagingControl1.Location = new System.Drawing.Point(8, 32);
            this.icImagingControl1.Name = "icImagingControl1";
            this.icImagingControl1.Size = new System.Drawing.Size(360, 240);
            this.icImagingControl1.TabIndex = 5;
            this.icImagingControl1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseMove);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(376, 357);
            this.Controls.Add(this.icImagingControl1);
            this.Controls.Add(this.txtImageData);
            this.Controls.Add(this.lblCoords);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Name = "Form1";
            this.Text = "Accessing image data";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			icImagingControl1.ShowDeviceSettingsDialog();

			if( !icImagingControl1.DeviceValid )
			{
				Close();
				return;
			}

			icImagingControl1.LiveCaptureContinuous = true;
			icImagingControl1.MemoryCurrentGrabberColorformat = TIS.Imaging.ICImagingControlColorformats.ICRGB24;

			icImagingControl1.LiveStart();
		}
		private void icImagingControl1_MouseMove(object sender, MouseEventArgs e)
		{
			lblCoords.Text = e.X + "," + e.Y;

			TIS.Imaging.ImageBuffer ib = icImagingControl1.ImageActiveBuffer;
			ib.Lock();
            
			if( e.X < ib.PixelPerLine && e.Y < ib.Lines )
			{
				byte red, green, blue;
				getImageColorValueRGB24( ib, e.X, e.Y, out red, out green, out blue );

				txtImageData.Text = string.Format( "Red\t=  {0}\r\nGreen\t=  {1}\r\nBlue\t=  {2}", red, green, blue );
			}
			else
			{
				txtImageData.Text = "<Outside of image>";
			}

			ib.Unlock();
		}
		private void getImageColorValueRGB24( TIS.Imaging.ImageBuffer ib, int x, int y, out byte red, out byte green, out byte blue )
		{
			int indexXred = x * 3 + 2;
			int indexXgreen = x * 3 + 1;
			int indexXblue = x * 3;

			int indexY = ib.Lines - y - 1;

			red = ib[ indexXred, indexY ];
			green = ib[ indexXgreen, indexY ];
			blue = ib[ indexXblue, indexY ];
		}
	}
}
