#pragma  once

#include <assert.h>
#include <tisudshl.h>

using namespace _DSHOWLIB_NAMESPACE;

class CClippingFilter: public _DSHOWLIB_NAMESPACE::FrameFilterImpl<CClippingFilter>
{

	public:
		CClippingFilter();
		static _DSHOWLIB_NAMESPACE::FilterInfo getStaticFilterInfo();

		// Parameter input and output methods
		tFilterError    setEnabled( bool bVal );
		tFilterError    getEnabled( bool &bVal );

		tFilterError    setThreshold( long lVal );
		tFilterError    getThreshold( long &lVal );

		tFilterError    setClipAboveThreshold( bool val );
		tFilterError    getClipAboveThreshold( bool& val );

		tFilterError    setFillMode( long val );
		tFilterError    getFillMode( long& val );

		tFilterError    setFillColor( long val );
		tFilterError    getFillColor( long& val );
		
		// Property dialog methods
		bool hasDialog() const;
		bool callDialog( HWND );
	protected:
		virtual void    getSupportedInputTypes( FrameTypeInfoArray& arr ) const ;
		virtual bool    getTransformOutputTypes( const FrameTypeInfo& in_type, FrameTypeInfoArray& out_types ) const;
		virtual bool    transform( const IFrame& src, IFrame& dest );

	private:
		bool m_bEnabled;			// This flag is used to enable and disable the filter.
		long m_Threshold;			// This is the threshold value. Pixels with a brightness
									// above this value will be clipped

		bool m_ClipAboveThreshold;	// If true: all pixels above the threshold are marked
									// If false: all pixels below the threshold are marked
		int m_FillMode;				// Fill Mode: 0 -> pattern, 1+ -> color
		COLORREF m_FillColor;		// Fill Color
};

