// SetParameterSimple.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <conio.h>

#define UDSHL_LIB_BASEDIR "../../../output/"
#include "tisudshl.h"      // IC Imaging Control Class Library

// Add the file "../../../Samples\VC71\Common\SimplePropertyAccess.cpp" to the project.
// In the project C++ settings for this files disable the use of the precompiled header file "stdafx.h".

#include "../../../Samples\VC71\Common\SimplePropertyAccess.h"

using namespace DShowLib;

int _tmain(int argc, _TCHAR* argv[])
{

	Grabber cGrabber;

	InitLibrary(0);

	// Open a video capture device.
	cGrabber.showDevicePage();

	if( !cGrabber.isDevValid() ) return 0;

	// Create the simple property class using the available properties of the selected device.
	CSimplePropertyAccess cSimpleProperty( cGrabber.getAvailableVCDProperties() );

	// Disable all property automatics
	cSimpleProperty.setAuto(VCDID_Gain, false);
	cSimpleProperty.setAuto(VCDID_WhiteBalance, false);
	cSimpleProperty.setAuto(VCDID_Brightness, false);

	// Now set the neutral values
	// Gain neutral is 180 for FireWire and 260 for USB cameras of The Imaging Source.
	cSimpleProperty.setValue(VCDID_Gain, 260);
	cSimpleProperty.setValue(VCDElement_WhiteBalanceBlue, 32);
	cSimpleProperty.setValue(VCDElement_WhiteBalanceRed, 32);
	cSimpleProperty.setValue(VCDID_Brightness, 0);
	cSimpleProperty.setValue(VCDID_Gamma, 10);
	cSimpleProperty.setValue(VCDID_Hue, 180);
	cSimpleProperty.setValue(VCDID_Saturation, 127);

	// Show the live video.
	printf("Press any key to stop the live video.\n");
	cGrabber.startLive();
	while (!kbhit());
	cGrabber.stopLive();

	ExitLibrary();
	return 0;
}

